diff --git a/camel/camel-exchange-store.c b/camel/camel-exchange-store.c
index 66fe9bd..0d7a7fb 100644
--- a/camel/camel-exchange-store.c
+++ b/camel/camel-exchange-store.c
@@ -34,6 +34,7 @@
 #include "camel-exchange-store.h"
 #include "camel-exchange-folder.h"
 #include "camel-exchange-summary.h"
+#include "camel-exchange-utils.h"
 
 #define SUBFOLDER_DIR_NAME     "subfolders"
 #define SUBFOLDER_DIR_NAME_LEN 10
@@ -84,8 +85,6 @@ static void		exchange_unsubscribe_folder (CamelStore *store,
 						CamelException *ex);
 static gboolean exchange_can_refresh_folder (CamelStore *store, CamelFolderInfo *info, CamelException *ex);
 
-static void stub_notification (CamelObject *object, gpointer event_data, gpointer user_data);
-
 static void
 class_init (CamelExchangeStoreClass *camel_exchange_store_class)
 {
@@ -137,11 +136,6 @@ init (CamelExchangeStore *exch, CamelExchangeStoreClass *klass)
 static void
 finalize (CamelExchangeStore *exch)
 {
-	if (exch->stub) {
-		camel_object_unref (CAMEL_OBJECT (exch->stub));
-		exch->stub = NULL;
-	}
-
 	g_free (exch->trash_name);
 
 	if (exch->folders_lock)
@@ -292,8 +286,6 @@ construct (CamelService *service, CamelSession *session,
 
 	if (!(exch->storage_path = camel_session_get_storage_path (session, service, ex)))
 		return;
-
-	exch->stub = NULL;
 }
 
 extern CamelServiceAuthType camel_exchange_password_authtype;
@@ -354,66 +346,28 @@ camel_exchange_forget_password (CamelService *service, CamelException *ex)
 	}
 }
 
-static void
-update_camel_stub (gpointer folder_name, gpointer folder, gpointer user_data)
-{
-	CamelExchangeFolder *exch_folder = CAMEL_EXCHANGE_FOLDER (folder);
-	if (exch_folder)
-		exch_folder->stub = (CamelStub *)user_data;
-}
-
 static gboolean
 exchange_connect (CamelService *service, CamelException *ex)
 {
 	CamelExchangeStore *exch = CAMEL_EXCHANGE_STORE (service);
-	gchar *real_user, *socket_path, *dot_exchange_username, *user_at_host;
 	gchar *password = NULL;
 	guint32 connect_status;
 	gboolean online_mode = FALSE;
 
 	/* This lock is only needed for offline operation. exchange_connect
-	   is called many times in offline to ensure we are connected atleast
-	   to the mail stub. Think twice before changing anything here.*/
+	   is called many times in offline. */
 
 	g_mutex_lock (exch->connect_lock);
 
 	online_mode = camel_session_is_online (service->session);
-
-	if (exch->stub == NULL) {
-		real_user = strpbrk (service->url->user, "\\/");
-		if (real_user)
-			real_user++;
-		else
-			real_user = service->url->user;
-		dot_exchange_username = g_strdup_printf (".exchange-%s", g_get_user_name ());
-		user_at_host = g_strdup_printf ("%s@%s", real_user, service->url->host);
-		e_filename_make_safe (user_at_host);
-		socket_path = g_build_filename (g_get_tmp_dir (),
-						dot_exchange_username,
-						user_at_host,
-						NULL);
-		g_free (dot_exchange_username);
-		g_free (user_at_host);
-
-		exch->stub = camel_stub_new (socket_path, _("Evolution Exchange backend process"), ex);
-		g_free (socket_path);
-		if (!exch->stub) {
-			g_mutex_unlock (exch->connect_lock);
-			return FALSE;
-		}
-
-		camel_object_hook_event (CAMEL_OBJECT (exch->stub), "notification",
-					 stub_notification, exch);
-	} else if (!online_mode && exch->stub_connected) {
+/*	if (!online_mode) {
 		g_mutex_unlock (exch->connect_lock);
 		return TRUE;
 	}
-
+*/
 	if (online_mode) {
 		camel_exchange_get_password (service, ex);
 		if (camel_exception_is_set (ex)) {
-			camel_object_unref (exch->stub);
-			exch->stub = NULL;
 			g_mutex_unlock (exch->connect_lock);
 			return FALSE;
 		}
@@ -421,16 +375,10 @@ exchange_connect (CamelService *service, CamelException *ex)
 	}
 
 	/* Initialize the stub connection */
-	if (!camel_stub_send (exch->stub, NULL, CAMEL_STUB_CMD_CONNECT,
-			      CAMEL_STUB_ARG_STRING, password,
-			      CAMEL_STUB_ARG_RETURN,
-			      CAMEL_STUB_ARG_UINT32, &connect_status,
-			      CAMEL_STUB_ARG_END)) {
+	if (!camel_exchange_utils_connect (service, password, &connect_status, ex)) {
 		/* The user cancelled the connection attempt. */
-		camel_exception_set (ex, CAMEL_EXCEPTION_USER_CANCEL,
-				     "Cancelled");
-		camel_object_unref (exch->stub);
-		exch->stub = NULL;
+		if (!camel_exception_is_set (ex))
+			camel_exception_set (ex, CAMEL_EXCEPTION_USER_CANCEL, "Cancelled");
 		g_mutex_unlock (exch->connect_lock);
 		return FALSE;
 	}
@@ -440,16 +388,10 @@ exchange_connect (CamelService *service, CamelException *ex)
 		camel_exception_set (ex, CAMEL_EXCEPTION_SYSTEM,
 				     _("Could not authenticate to server. "
 				       "(Password incorrect?)\n\n"));
-		camel_object_unref (exch->stub);
-		exch->stub = NULL;
 		g_mutex_unlock (exch->connect_lock);
 		return FALSE;
-	} else {
-		exch->stub_connected = TRUE;
 	}
 
-	g_hash_table_foreach (exch->folders, update_camel_stub, exch->stub);
-
 	g_mutex_unlock (exch->connect_lock);
 
 	return TRUE;
@@ -458,13 +400,8 @@ exchange_connect (CamelService *service, CamelException *ex)
 static gboolean
 exchange_disconnect (CamelService *service, gboolean clean, CamelException *ex)
 {
-
-	CamelExchangeStore *exch = CAMEL_EXCHANGE_STORE (service);
-
-	if (exch->stub) {
-		exch->stub = NULL;
-	}
-
+	/* CamelExchangeStore *exch = CAMEL_EXCHANGE_STORE (service); */
+	/* keep account connect as it can be used for other parts like cal, gal or addressbook? */
 	return TRUE;
 }
 
@@ -514,7 +451,7 @@ exchange_get_folder (CamelStore *store, const gchar *folder_name,
 
 	if (!camel_exchange_folder_construct (folder, store, folder_name,
 					      flags, folder_dir, ((CamelOfflineStore *) store)->state,
-					      exch->stub, ex)) {
+					      ex)) {
 		gchar *key;
 		g_mutex_lock (exch->folders_lock);
 		if (g_hash_table_lookup_extended (exch->folders, folder_name,
@@ -541,23 +478,18 @@ exchange_get_folder (CamelStore *store, const gchar *folder_name,
 static gboolean
 exchange_folder_subscribed (CamelStore *store, const gchar *folder_name)
 {
-	CamelExchangeStore *exch = CAMEL_EXCHANGE_STORE (store);
-	guint32 is_subscribed;
+	gboolean is_subscribed = FALSE;
 
 	d(printf ("is subscribed folder : %s\n", folder_name));
 	if (((CamelOfflineStore *) store)->state == CAMEL_OFFLINE_STORE_NETWORK_UNAVAIL) {
 		return FALSE;
 	}
 
-	if (!camel_stub_send (exch->stub, NULL, CAMEL_STUB_CMD_IS_SUBSCRIBED_FOLDER,
-			      CAMEL_STUB_ARG_FOLDER, folder_name,
-			      CAMEL_STUB_ARG_RETURN,
-			      CAMEL_STUB_ARG_UINT32, &is_subscribed,
-			      CAMEL_STUB_ARG_END)) {
+	if (!camel_exchange_utils_is_subscribed_folder (CAMEL_SERVICE (store), folder_name, &is_subscribed, NULL)) {
 		return FALSE;
 	}
 
-	return is_subscribed ? TRUE : FALSE;
+	return is_subscribed;
 }
 
 static void
@@ -572,9 +504,7 @@ exchange_subscribe_folder (CamelStore *store, const gchar *folder_name,
 		return;
 	}
 
-	camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_SUBSCRIBE_FOLDER,
-			      CAMEL_STUB_ARG_FOLDER, folder_name,
-			      CAMEL_STUB_ARG_END);
+	camel_exchange_utils_subscribe_folder (CAMEL_SERVICE (store), folder_name, ex);
 }
 
 static void
@@ -589,9 +519,7 @@ exchange_unsubscribe_folder (CamelStore *store, const gchar *folder_name,
 		return;
 	}
 
-	camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_UNSUBSCRIBE_FOLDER,
-			      CAMEL_STUB_ARG_FOLDER, folder_name,
-			      CAMEL_STUB_ARG_END);
+	camel_exchange_utils_unsubscribe_folder (CAMEL_SERVICE (store), folder_name, ex);
 }
 
 static CamelFolder *
@@ -602,10 +530,7 @@ get_trash (CamelStore *store, CamelException *ex)
 	RETURN_VAL_IF_NOT_CONNECTED (exch, ex, NULL);
 
 	if (!exch->trash_name) {
-		if (!camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_GET_TRASH_NAME,
-				      CAMEL_STUB_ARG_RETURN,
-				      CAMEL_STUB_ARG_STRING, &exch->trash_name,
-				      CAMEL_STUB_ARG_END))
+		if (!camel_exchange_utils_get_trash_name (CAMEL_SERVICE (store), &exch->trash_name, ex))
 			return NULL;
 	}
 
@@ -614,7 +539,7 @@ get_trash (CamelStore *store, CamelException *ex)
 
 /* Note: steals @name and @uri */
 static CamelFolderInfo *
-make_folder_info (CamelExchangeStore *exch, gchar *name, gchar *uri,
+make_folder_info (CamelExchangeStore *exch, gchar *name, const gchar *uri,
 		  gint unread_count, gint flags)
 {
 	CamelFolderInfo *info;
@@ -657,27 +582,27 @@ make_folder_info (CamelExchangeStore *exch, gchar *name, gchar *uri,
 	}
 	info->unread = unread_count;
 
-	if (flags & CAMEL_STUB_FOLDER_NOSELECT)
+	if (flags & CAMEL_FOLDER_NOSELECT)
 		info->flags = CAMEL_FOLDER_NOSELECT;
 
-	if (flags & CAMEL_STUB_FOLDER_SYSTEM)
+	if (flags & CAMEL_FOLDER_SYSTEM)
 		info->flags |= CAMEL_FOLDER_SYSTEM;
 
-	if (flags & CAMEL_STUB_FOLDER_TYPE_INBOX)
+	if ((flags & CAMEL_FOLDER_TYPE_MASK) == CAMEL_FOLDER_TYPE_INBOX)
 		info->flags |= CAMEL_FOLDER_TYPE_INBOX;
 
-	if (flags & CAMEL_STUB_FOLDER_TYPE_TRASH)
+	if ((flags & CAMEL_FOLDER_TYPE_MASK) == CAMEL_FOLDER_TYPE_TRASH)
 		info->flags |= CAMEL_FOLDER_TYPE_TRASH;
 
-	if (flags & CAMEL_STUB_FOLDER_TYPE_SENT)
+	if ((flags & CAMEL_FOLDER_TYPE_MASK) == CAMEL_FOLDER_TYPE_SENT)
 		info->flags |= CAMEL_FOLDER_TYPE_SENT;
 
-	if (flags & CAMEL_STUB_FOLDER_SUBSCRIBED) {
+	if (flags & CAMEL_FOLDER_SUBSCRIBED) {
 		info->flags |= CAMEL_FOLDER_SUBSCRIBED;
 		d(printf ("MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMmark as subscribed\n"));
 	}
 
-	if (flags & CAMEL_STUB_FOLDER_NOCHILDREN)
+	if (flags & CAMEL_FOLDER_NOCHILDREN)
 		info->flags |= CAMEL_FOLDER_NOCHILDREN;
 	return info;
 }
@@ -713,9 +638,9 @@ static CamelFolderInfo *
 exchange_get_folder_info (CamelStore *store, const gchar *top, guint32 flags, CamelException *ex)
 {
 	CamelExchangeStore *exch = CAMEL_EXCHANGE_STORE (store);
-	GPtrArray *folders, *folder_names, *folder_uris;
-	GArray *unread_counts;
-	GArray *folder_flags;
+	GPtrArray *folders, *folder_names = NULL, *folder_uris = NULL;
+	GArray *unread_counts = NULL;
+	GArray *folder_flags = NULL;
 	CamelFolderInfo *info;
 	guint32 store_flags = 0;
 	gint i;
@@ -741,25 +666,14 @@ exchange_get_folder_info (CamelStore *store, const gchar *top, guint32 flags, Ca
 		return NULL;
 	}
 
-	if (camel_stub_marshal_eof (exch->stub->cmd))
-		return NULL;
-
 	if (flags & CAMEL_STORE_FOLDER_INFO_RECURSIVE)
-		store_flags |= CAMEL_STUB_STORE_FOLDER_INFO_RECURSIVE;
+		store_flags |= CAMEL_STORE_FOLDER_INFO_RECURSIVE;
 	if (flags & CAMEL_STORE_FOLDER_INFO_SUBSCRIBED)
-		store_flags |= CAMEL_STUB_STORE_FOLDER_INFO_SUBSCRIBED;
+		store_flags |= CAMEL_STORE_FOLDER_INFO_SUBSCRIBED;
 	if (flags & CAMEL_STORE_FOLDER_INFO_SUBSCRIPTION_LIST)
-		store_flags |= CAMEL_STUB_STORE_FOLDER_INFO_SUBSCRIPTION_LIST;
-
-	if (!camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_GET_FOLDER_INFO,
-			      CAMEL_STUB_ARG_STRING, top,
-			      CAMEL_STUB_ARG_UINT32, store_flags,
-			      CAMEL_STUB_ARG_RETURN,
-			      CAMEL_STUB_ARG_STRINGARRAY, &folder_names,
-			      CAMEL_STUB_ARG_STRINGARRAY, &folder_uris,
-			      CAMEL_STUB_ARG_UINT32ARRAY, &unread_counts,
-			      CAMEL_STUB_ARG_UINT32ARRAY, &folder_flags,
-			      CAMEL_STUB_ARG_END)) {
+		store_flags |= CAMEL_STORE_FOLDER_INFO_SUBSCRIPTION_LIST;
+
+	if (!camel_exchange_utils_get_folder_info (CAMEL_SERVICE (store), top, store_flags, &folder_names, &folder_uris, &unread_counts, &folder_flags, ex)) {
 		return NULL;
 	}
 	if (!folder_names) {
@@ -774,12 +688,13 @@ exchange_get_folder_info (CamelStore *store, const gchar *top, guint32 flags, Ca
 	for (i = 0; i < folder_names->len; i++) {
 		info = make_folder_info (exch, folder_names->pdata[i],
 					 folder_uris->pdata[i],
-					 g_array_index (unread_counts, int, i),
-					 g_array_index (folder_flags, int, i));
+					 g_array_index (unread_counts, gint, i),
+					 g_array_index (folder_flags, gint, i));
 		if (info)
 			g_ptr_array_add (folders, info);
 	}
 	g_ptr_array_free (folder_names, TRUE);
+	g_ptr_array_foreach (folder_uris, (GFunc) g_free, NULL);
 	g_ptr_array_free (folder_uris, TRUE);
 	g_array_free (unread_counts, TRUE);
 	g_array_free (folder_flags, TRUE);
@@ -807,19 +722,15 @@ exchange_create_folder (CamelStore *store, const gchar *parent_name,
 		return NULL;
 	}
 
-	if (!camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_CREATE_FOLDER,
-			      CAMEL_STUB_ARG_FOLDER, parent_name,
-			      CAMEL_STUB_ARG_STRING, folder_name,
-			      CAMEL_STUB_ARG_RETURN,
-			      CAMEL_STUB_ARG_STRING, &folder_uri,
-			      CAMEL_STUB_ARG_UINT32, &unread_count,
-			      CAMEL_STUB_ARG_UINT32, &flags,
-			      CAMEL_STUB_ARG_END))
+	if (!camel_exchange_utils_create_folder (CAMEL_SERVICE (store), parent_name, folder_name, &folder_uri, &unread_count, &flags, ex))
 		return NULL;
 
 	info = make_folder_info (exch, g_strdup (folder_name),
 				 folder_uri, unread_count, flags);
 	info->flags |= CAMEL_FOLDER_NOCHILDREN;
+
+	g_free (folder_uri);
+
 	return info;
 }
 
@@ -834,9 +745,7 @@ exchange_delete_folder (CamelStore *store, const gchar *folder_name,
 		return;
 	}
 
-	camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_DELETE_FOLDER,
-			 CAMEL_STUB_ARG_FOLDER, folder_name,
-			 CAMEL_STUB_ARG_END);
+	camel_exchange_utils_delete_folder (CAMEL_SERVICE (store), folder_name, ex);
 }
 
 static void
@@ -857,15 +766,7 @@ exchange_rename_folder (CamelStore *store, const gchar *old_name,
 		camel_exception_set (ex, CAMEL_EXCEPTION_SYSTEM, _("Cannot rename folder in offline mode."));
 		return;
 	}
-	if (!camel_stub_send (exch->stub, ex, CAMEL_STUB_CMD_RENAME_FOLDER,
-			      CAMEL_STUB_ARG_STRING, old_name,
-			      CAMEL_STUB_ARG_STRING, new_name,
-			      CAMEL_STUB_ARG_RETURN,
-			      CAMEL_STUB_ARG_STRINGARRAY, &folder_names,
-			      CAMEL_STUB_ARG_STRINGARRAY, &folder_uris,
-			      CAMEL_STUB_ARG_UINT32ARRAY, &unread_counts,
-			      CAMEL_STUB_ARG_UINT32ARRAY, &folder_flags,
-			      CAMEL_STUB_ARG_END)) {
+	if (!camel_exchange_utils_rename_folder (CAMEL_SERVICE (store), old_name, new_name, &folder_names, &folder_uris, &unread_counts, &folder_flags, ex)) {
 		return;
 	}
 
@@ -887,6 +788,7 @@ exchange_rename_folder (CamelStore *store, const gchar *old_name,
 			g_ptr_array_add (folders, info);
 	}
 	g_ptr_array_free (folder_names, TRUE);
+	g_ptr_array_foreach (folder_uris, (GFunc) g_free, NULL);
 	g_ptr_array_free (folder_uris, TRUE);
 	g_array_free (unread_counts, TRUE);
 	g_array_free (folder_flags, TRUE);
@@ -914,291 +816,53 @@ exchange_rename_folder (CamelStore *store, const gchar *old_name,
 
 }
 
-static void
-stub_notification (CamelObject *object, gpointer event_data, gpointer user_data)
+static gboolean
+exchange_can_refresh_folder (CamelStore *store, CamelFolderInfo *info, CamelException *ex)
 {
-	CamelStub *stub = CAMEL_STUB (object);
-	CamelExchangeStore *exch = CAMEL_EXCHANGE_STORE (user_data);
-	guint32 retval = GPOINTER_TO_UINT (event_data);
-
-	switch (retval) {
-	case CAMEL_STUB_RETVAL_NEW_MESSAGE:
-	{
-		CamelExchangeFolder *folder;
-		gchar *folder_name, *uid, *headers, *href;
-		guint32 flags, size;
-
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &uid) == -1 ||
-		    camel_stub_marshal_decode_uint32 (stub->status, &flags) == -1 ||
-		    camel_stub_marshal_decode_uint32 (stub->status, &size) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &headers) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &href) == -1)
-			return;
-
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder) {
-			camel_exchange_folder_add_message (folder, uid, flags,
-							   size, headers, href);
-		}
-
-		g_free (folder_name);
-		g_free (uid);
-		g_free (headers);
-		g_free (href);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_REMOVED_MESSAGE:
-	{
-		CamelExchangeFolder *folder;
-		gchar *folder_name, *uid;
-		CamelMessageInfo *info;
-
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &uid) == -1)
-			return;
-
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder && (info = camel_folder_summary_uid (((CamelFolder *)folder)->summary, uid))) {
-			camel_message_info_free (info);
-			camel_exchange_folder_remove_message (folder, uid);
-		}
-
-		g_free (folder_name);
-		g_free (uid);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_CHANGED_MESSAGE:
-	{
-		CamelExchangeFolder *folder;
-		gchar *folder_name, *uid;
-
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &uid) == -1)
-			break;
-
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder)
-			camel_exchange_folder_uncache_message (folder, uid);
-
-		g_free (folder_name);
-		g_free (uid);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_CHANGED_FLAGS:
-	{
-		CamelExchangeFolder *folder;
-		gchar *folder_name, *uid;
-		guint32 flags;
-
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &uid) == -1 ||
-		    camel_stub_marshal_decode_uint32 (stub->status, &flags) == -1)
-			break;
-
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder)
-			camel_exchange_folder_update_message_flags (folder, uid, flags);
-
-		g_free (folder_name);
-		g_free (uid);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_CHANGED_FLAGS_EX:
-	{
-		CamelExchangeFolder *folder;
-		gchar *folder_name, *uid;
-		guint32 flags;
-		guint32 mask;
-
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &uid) == -1 ||
-		    camel_stub_marshal_decode_uint32 (stub->status, &flags) == -1 ||
-		    camel_stub_marshal_decode_uint32 (stub->status, &mask) == -1)
-			break;
-
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder)
-			camel_exchange_folder_update_message_flags_ex (folder, uid,
-								       flags, mask);
-
-		g_free (folder_name);
-		g_free (uid);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_CHANGED_TAG:
-	{
-		CamelExchangeFolder *folder;
-		gchar *folder_name, *uid, *name, *value;
-
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &uid) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &value) == -1)
-			break;
-
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder)
-			camel_exchange_folder_update_message_tag (folder, uid, name, value);
-
-		g_free (folder_name);
-		g_free (uid);
-		g_free (name);
-		g_free (value);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_FREEZE_FOLDER:
-	{
-		CamelFolder *folder;
-		gchar *folder_name;
-
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1)
-			break;
-
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder)
-			camel_folder_freeze (folder);
-
-		g_free (folder_name);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_THAW_FOLDER:
-	{
-		CamelFolder *folder;
-		gchar *folder_name;
-
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1)
-			break;
-
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder)
-			camel_folder_thaw (folder);
-
-		g_free (folder_name);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_FOLDER_CREATED:
-	{
-		CamelFolderInfo *info;
-		gchar *name, *uri;
-
-		if (camel_stub_marshal_decode_string (stub->status, &name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &uri) == -1)
-			break;
-
-		info = make_folder_info (exch, name, uri, -1, 0);
-		info->flags |= CAMEL_FOLDER_NOCHILDREN;
-		camel_object_trigger_event (CAMEL_OBJECT (exch),
-					    "folder_subscribed", info);
-		camel_folder_info_free (info);
-		break;
-	}
-
-	case CAMEL_STUB_RETVAL_FOLDER_DELETED:
-	{
-		CamelFolderInfo *info;
-		CamelFolder *folder;
-		gchar *name, *uri;
-
-		if (camel_stub_marshal_decode_string (stub->status, &name) == -1 ||
-		    camel_stub_marshal_decode_string (stub->status, &uri) == -1)
-			break;
-
-		info = make_folder_info (exch, name, uri, -1, 0);
+	gboolean res;
 
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, info->full_name);
-		if (folder) {
-			g_hash_table_remove (exch->folders, info->full_name);
-			camel_object_unref (CAMEL_OBJECT (folder));
-		}
-		g_mutex_unlock (exch->folders_lock);
+	res = CAMEL_STORE_CLASS(parent_class)->can_refresh_folder (store, info, ex) ||
+	      (camel_url_get_param (((CamelService *)store)->url, "check_all") != NULL);
 
-		camel_object_trigger_event (CAMEL_OBJECT (exch),
-					    "folder_unsubscribed", info);
-		camel_folder_info_free (info);
-		break;
-	}
+	return res;
+}
 
-	case CAMEL_STUB_RETVAL_FOLDER_SET_READONLY:
-	{
-		CamelFolder *folder;
-		gchar *folder_name;
-		guint32 readonly;
+void
+camel_exchange_store_folder_created (CamelExchangeStore *estore, const gchar *name, const gchar *uri)
+{
+	CamelFolderInfo *info;
 
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1 ||
-		    camel_stub_marshal_decode_uint32 (stub->status, &readonly) == -1)
-			break;
+	g_return_if_fail (estore != NULL);
+	g_return_if_fail (CAMEL_IS_EXCHANGE_STORE (estore));
 
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder) {
-			camel_exchange_summary_set_readonly (folder->summary, readonly ? TRUE : FALSE);
-		}
+	info = make_folder_info (estore, g_strdup (name), uri, -1, 0);
+	info->flags |= CAMEL_FOLDER_NOCHILDREN;
 
-		g_free (folder_name);
-		break;
-	}
+	camel_object_trigger_event (CAMEL_OBJECT (estore), "folder_subscribed", info);
 
-	case CAMEL_STUB_RETVAL_FOLDER_SET_ARTICLE_NUM:
-	{
-		CamelFolder *folder;
-		gchar *folder_name;
-		guint32 high_article_num;
+	camel_folder_info_free (info);
+}
 
-		if (camel_stub_marshal_decode_folder (stub->status, &folder_name) == -1 ||
-		    camel_stub_marshal_decode_uint32 (stub->status, &high_article_num) == -1)
-			break;
+void
+camel_exchange_store_folder_deleted (CamelExchangeStore *estore, const gchar *name, const gchar *uri)
+{
+	CamelFolderInfo *info;
+	CamelFolder *folder;
 
-		g_mutex_lock (exch->folders_lock);
-		folder = g_hash_table_lookup (exch->folders, folder_name);
-		g_mutex_unlock (exch->folders_lock);
-		if (folder) {
-			camel_exchange_summary_set_article_num (folder->summary, high_article_num);
-		}
+	g_return_if_fail (estore != NULL);
+	g_return_if_fail (CAMEL_IS_EXCHANGE_STORE (estore));
 
-		g_free (folder_name);
-		break;
-	}
+	info = make_folder_info (estore, g_strdup (name), uri, -1, 0);
 
-	default:
-		g_critical ("%s: Uncaught case (%d)", G_STRLOC, retval);
-		break;
+	g_mutex_lock (estore->folders_lock);
+	folder = g_hash_table_lookup (estore->folders, info->full_name);
+	if (folder) {
+		g_hash_table_remove (estore->folders, info->full_name);
+		camel_object_unref (CAMEL_OBJECT (folder));
 	}
-}
+	g_mutex_unlock (estore->folders_lock);
 
-static gboolean
-exchange_can_refresh_folder (CamelStore *store, CamelFolderInfo *info, CamelException *ex)
-{
-	gboolean res;
-
-	res = CAMEL_STORE_CLASS(parent_class)->can_refresh_folder (store, info, ex) ||
-	      (camel_url_get_param (((CamelService *)store)->url, "check_all") != NULL);
+	camel_object_trigger_event (CAMEL_OBJECT (estore), "folder_unsubscribed", info);
 
-	return res;
+	camel_folder_info_free (info);
 }
diff --git a/camel/camel-exchange-store.h b/camel/camel-exchange-store.h
index 5aeae45..d634fb0 100644
--- a/camel/camel-exchange-store.h
+++ b/camel/camel-exchange-store.h
@@ -10,7 +10,6 @@ G_BEGIN_DECLS
 
 #include <camel/camel-store.h>
 #include <camel/camel-offline-store.h>
-#include "camel-stub.h"
 
 #define CAMEL_EXCHANGE_STORE_TYPE     (camel_exchange_store_get_type ())
 #define CAMEL_EXCHANGE_STORE(obj)     (CAMEL_CHECK_CAST((obj), CAMEL_EXCHANGE_STORE_TYPE, CamelExchangeStore))
@@ -20,13 +19,11 @@ G_BEGIN_DECLS
 typedef struct {
 	CamelOfflineStore parent_object;
 
-	CamelStub *stub;
 	gchar *storage_path, *base_url;
 	gchar *trash_name;
 	GHashTable *folders;
 	GMutex *folders_lock;
 
-	gboolean stub_connected;
 	GMutex *connect_lock;
 
 } CamelExchangeStore;
@@ -41,6 +38,9 @@ CamelType camel_exchange_store_get_type (void);
 
 gboolean camel_exchange_store_connected (CamelExchangeStore *store, CamelException *ex);
 
+void camel_exchange_store_folder_created (CamelExchangeStore *estore, const gchar *name, const gchar *uri);
+void camel_exchange_store_folder_deleted (CamelExchangeStore *estore, const gchar *name, const gchar *uri);
+
 G_END_DECLS
 
 #endif /* CAMEL_EXCHANGE_STORE_H */
diff --git a/camel/camel-exchange-summary.c b/camel/camel-exchange-summary.c
index 0924e29..0e91dde 100644
--- a/camel/camel-exchange-summary.c
+++ b/camel/camel-exchange-summary.c
@@ -32,10 +32,10 @@
 #include <camel/camel-offline-store.h>
 #include <camel/camel-string-utils.h>
 
-#include "camel-stub.h"
 #include "camel-exchange-folder.h"
 #include "camel-exchange-journal.h"
 #include "camel-exchange-summary.h"
+#include "camel-exchange-utils.h"
 
 #define CAMEL_EXCHANGE_SUMMARY_VERSION (2)
 
@@ -389,7 +389,6 @@ check_for_trash (CamelFolder *folder)
 static gboolean
 expunge_mail (CamelFolder *folder, CamelMessageInfo *info)
 {
-	CamelExchangeFolder *exchange_folder = (CamelExchangeFolder *) folder;
 	GPtrArray *uids = g_ptr_array_new ();
 	gchar *uid = g_strdup (info->uid);
 	CamelException lex;
@@ -397,11 +396,7 @@ expunge_mail (CamelFolder *folder, CamelMessageInfo *info)
 	g_ptr_array_add (uids, uid);
 
 	camel_exception_init (&lex);
-	camel_stub_send (exchange_folder->stub, &lex,
-			 CAMEL_STUB_CMD_EXPUNGE_UIDS,
-			 CAMEL_STUB_ARG_FOLDER, folder->full_name,
-			 CAMEL_STUB_ARG_STRINGARRAY, uids,
-			 CAMEL_STUB_ARG_END);
+	camel_exchange_utils_expunge_uids (CAMEL_SERVICE (folder->parent_store), folder->full_name, uids, &lex);
 
 	g_ptr_array_free (uids, TRUE);
 	return camel_exception_is_set (&lex);
@@ -422,13 +417,7 @@ info_set_flags(CamelMessageInfo *info, guint32 flags, guint32 set)
 			    check_for_trash (folder)) {
 				return expunge_mail (folder, info);
 			} else {
-				camel_stub_send_oneway (((CamelExchangeFolder *)folder)->stub,
-							CAMEL_STUB_CMD_SET_MESSAGE_FLAGS,
-							CAMEL_STUB_ARG_FOLDER, folder->full_name,
-							CAMEL_STUB_ARG_STRING, info->uid,
-							CAMEL_STUB_ARG_UINT32, set,
-							CAMEL_STUB_ARG_UINT32, flags,
-							CAMEL_STUB_ARG_END);
+				camel_exchange_utils_set_message_flags (CAMEL_SERVICE (folder->parent_store), folder->full_name, info->uid, set, flags, NULL);
 				return CAMEL_FOLDER_SUMMARY_CLASS (parent_class)->info_set_flags(info, flags, set);
 			}
 		}
@@ -459,13 +448,8 @@ info_set_user_tag(CamelMessageInfo *info, const gchar *name, const gchar *value)
 
 	res = CAMEL_FOLDER_SUMMARY_CLASS (parent_class)->info_set_user_tag(info, name, value);
 	if (res && info->summary->folder && info->uid) {
-		camel_stub_send_oneway (((CamelExchangeFolder *)info->summary->folder)->stub,
-					CAMEL_STUB_CMD_SET_MESSAGE_TAG,
-					CAMEL_STUB_ARG_FOLDER, info->summary->folder->full_name,
-					CAMEL_STUB_ARG_STRING, info->uid,
-					CAMEL_STUB_ARG_STRING, name,
-					CAMEL_STUB_ARG_STRING, value,
-					CAMEL_STUB_ARG_END);
+		CamelFolder *folder = info->summary->folder;
+		camel_exchange_utils_set_message_tag (CAMEL_SERVICE (folder->parent_store), folder->full_name, info->uid, name, value, NULL);
 	}
 
 	return res;
diff --git a/camel/camel-exchange-transport.c b/camel/camel-exchange-transport.c
index cf33bba..2403b7e 100644
--- a/camel/camel-exchange-transport.c
+++ b/camel/camel-exchange-transport.c
@@ -26,7 +26,7 @@
 #include <glib/gi18n-lib.h>
 
 #include "camel-exchange-transport.h"
-#include "camel-stub.h"
+#include "camel-exchange-utils.h"
 
 #include <camel/camel-data-wrapper.h>
 #include <camel/camel-exception.h>
@@ -38,8 +38,6 @@
 
 #include <string.h>
 
-extern CamelStub *das_global_camel_stub;
-
 static gboolean exchange_send_to (CamelTransport *transport,
 				  CamelMimeMessage *message,
 				  CamelAddress *from,
@@ -111,6 +109,8 @@ exchange_send_to (CamelTransport *transport, CamelMimeMessage *message,
 		return FALSE;
 	}
 
+	g_free (url_string);
+
 	recipients_array = g_ptr_array_new ();
 	len = camel_address_length (recipients);
 	cia = CAMEL_INTERNET_ADDRESS (recipients);
@@ -119,7 +119,6 @@ exchange_send_to (CamelTransport *transport, CamelMimeMessage *message,
 			camel_exception_set (ex, CAMEL_EXCEPTION_SYSTEM,
 					     _("Cannot send message: one or more invalid recipients"));
 			g_ptr_array_free (recipients_array, TRUE);
-			g_free (url_string);
 			return FALSE;
 		}
 		g_ptr_array_add (recipients_array, (gchar *)addr);
@@ -129,21 +128,9 @@ exchange_send_to (CamelTransport *transport, CamelMimeMessage *message,
 		camel_exception_set (ex, CAMEL_EXCEPTION_SERVICE_UNAVAILABLE,
 				     _("Could not find 'From' address in message"));
 		g_ptr_array_free (recipients_array, TRUE);
-		g_free (url_string);
 		return FALSE;
 	}
 
-	if (!das_global_camel_stub) {
-		store = camel_session_get_store (service->session, url_string, ex);
-		if (!store) {
-			g_ptr_array_free (recipients_array, TRUE);
-			g_free (url_string);
-			return FALSE;
-		}
-		g_return_val_if_fail (das_global_camel_stub, FALSE);
-	}
-	g_free (url_string);
-
 	stream = camel_stream_mem_new ();
 	crlffilter = camel_mime_filter_crlf_new (CAMEL_MIME_FILTER_CRLF_ENCODE, CAMEL_MIME_FILTER_CRLF_MODE_CRLF_ONLY);
 	filtered_stream = camel_stream_filter_new_with_stream (stream);
@@ -177,12 +164,7 @@ exchange_send_to (CamelTransport *transport, CamelMimeMessage *message,
 		g_slist_free (bcc);
 	}
 
-	success = camel_stub_send (das_global_camel_stub, ex,
-				   CAMEL_STUB_CMD_SEND_MESSAGE,
-				   CAMEL_STUB_ARG_STRING, addr,
-				   CAMEL_STUB_ARG_STRINGARRAY, recipients_array,
-				   CAMEL_STUB_ARG_BYTEARRAY, CAMEL_STREAM_MEM (stream)->buffer,
-				   CAMEL_STUB_ARG_END);
+	success = camel_exchange_utils_send_message (CAMEL_SERVICE (transport), addr, recipients_array, CAMEL_STREAM_MEM (stream)->buffer, ex);
 
 	g_ptr_array_free (recipients_array, TRUE);
 	camel_object_unref (CAMEL_OBJECT (stream));
